/*
Sand3d
Copyright (C) 2007 - David Pascoe-Deslauriers

  This file is part of Sand3d.

    Sand3d is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Sand3d is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Sand3d; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include "world.h"
#include <stdlib.h>
#include <fstream>

using namespace std;

particle world::getParticleFrom(char *file, int id){
    fstream in;
    in.open(file,ios::in);
    
    char line[48];
    particle p;

    sprintf(p.name,"");
    p.fireid = -1;
    p.mass = 0;
    p.type = EMPTY;
    p.colour.x = 0;
    p.colour.y = 0;
    p.colour.z = 0;
    p.alpha = 0;
    p.combustion_counter = -1;
    p.fire = -1;
    p.phase = SKYHOOK;
    p.force = false;
    p.secondary_counter = -1;
    p.puts_out_fire = false;
    p.yrot = 0;
    p.explodes = false;
    p.destroy = true;

    int lineCount = 0;
    char param[24];
    int paramCount = 0;
    char value[24];
    int valueCount = 0;
    while(!in.eof()){
        in.getline(line,48,'\n');
        lineCount++;
        if (line[0] != '#' || line[0] != '/'){
                int charC = 0;
                while(paramCount < 24 && line[charC] != ' ' && line[charC] != '='){
                    param[paramCount++] = line[charC++];
                }
                while(line[charC] == ' ' || line[charC] == '='){
                    charC++;   
                }    
                while(valueCount < 24 && charC < 48 && line[charC] != ' ' && line[charC] != '\n' && line[charC] != '\0'&& line[charC] != '#' && line[charC] != '/'){
                    value[valueCount++] = line[charC++];
                }
                if (strcmp("version",param)){
                       if (atof(value) > VERSION){
//                            return (&particle);
                       }
                } else if (strcmp("name",param)) {
                    
                } else if (strcmp("mass",param)) {
                    
                } else if (strcmp("red",param)) {
                    
                } else if (strcmp("green",param)) {
                    
                } else if (strcmp("blue",param)){
                } else if (strcmp("alpha",param)){
                } else if (strcmp("flammable",param)){
                } else if (strcmp("burns",param)){
                } else if (strcmp("phase",param)){
                } else if (strcmp("putsoutfire",param)){
                } else if (strcmp("destroyable",param)){
                } else if (strcmp("explodes", param)){
                } else if (strcmp("secondary",param)){
                }      
        }    
    }    



    sprintf(p.name,"Eraser");
    p.mass = 0;
    p.type = id;
    p.colour.x = 0;
    p.colour.y = 0;
    p.colour.z = 0;
    p.alpha = 0;
    p.combustion_counter = -1;
    p.phase = world::SKYHOOK;
    p.fire = -1;
    p.fireid = -1;
    p.puts_out_fire = false;
    
    return p;
}

void world::SaveGame(){/*
    fstream out;
    out.open("save_game.sand3d",ios::out);
    out << x << "," << y "," << z << "\n";
    for (int a = 0; a < x; a++){
        for (int b = 0; b < y; b++){
            for(int c = 0; c < z; c++){
                out << w[a][b][c].type << ",";
            }
            out << "\n";
        }
        out << "\n";
    }    
    out.close;   */ 
}     
